unit UEKeys;
{
	========================================================================

	Modulo:	UEKeys	  	Tasko:	Specialaj klavaj kaj klavaraj funkcioj

    ========================================================================

    Funkcio:	Tiu chi modulo provizas chion necesan por provizi tri bazajn
    			klavarojn dorsosake al la klavaro aktuale uzata de la uzulo.
                Temas pri rektklavada E-Klavaro (kiel en Chapelilo) por
                Esperanto, senpasha klavaro por Esperanto baze de du sen-
                pashaj klavoj, kaj internacia klavaro permesanta atingi
                chiujn signojn de Latino 1.

                La fundamenta metodo konsistas el tio, ke lau specialaj klavoj
                au specialaj senpashaj klavoj oni por specifa dezirata signo
                nur provizore komutas al klavaro, kiu fakte entenas la
                signon kaj tiel ebligas ties enklavadon - tute Vindozkonforme.
                La enklavadon plenumas tiam la klaso per pseudo-klavpremoj.

                Speciale por Esperanto la instalilo modifas lau elekto de la
                uzulo konvenan jam ekzistantan Latin-3-an klavaron al la
                bezonoj de la rekta E-Klavaro. En tiu la klavoj

                	Q = S^, W = J^, X = C^, Y = G^.

                La mankantaj U~ kaj H^ povas esti atingataj per Alt-Ctrl plus
                la baza letero.

                Aldone estas funkcio por automate komuti al U~ post A au E.

                Paralele al la supraj ebloj oni povas difini du senpashajn
                klavojn, per kiuj oni povas atingi la supersignitajn literojn
                helpe de la bazaj literoj. Kiam la rekta klavaro estas
                ebligita, la senpashiloj povos aldone uzighi por atingi la
                praajn kvazau eklipsitajn ne-Esperantajn signojn.

                Por atingi chiujn diakritojn kaj simbolojn de Latino 1 oni
                povas uzi senpashajn klavojn Alt 5 ghis Alt 0 en kombino kun
                lauaj bazaj literoj au signoj. Kie eblas, funkcias kiel sen-
                pashilo parelele ankau Alt plus respektiva supersigno por
                efektivigi la samon.

                Char unu el la autoroj uzas ne-Germanan Usonan Dvorakan
                klavaron por la Germana, li aldonis kelkajn komfortajhojn
                por tiu chi tre speciala medio. Tiujn oni povas shalti kaj
                malshalti per la suba konstanto GERMANA. Normalokaze la
                konstanto estu "false".

                Notu, ke chiuj metodoj povas tute senprobleme samtempe esti
                aktivaj.

                La precipa metodo por chio trovighas en la klaso TKeys kaj
                fundamentas la necesan KeyProc por la eventtraktilo de
                Vindozo. Temas pri eKeyProc(). Tiu analizas la fluon de
                klaveventoj, serchante pri Esperantaj klavoj (Q, W, X, Y) kaj
                pri specialaj senpashiloj. En tiu metodo la redono eTraktita
                au eTraktoto ordonas Vindozon au forgesi au plu trakti la
                kaptitan klaveventon. Ofte Vindozo forgesu, kaj anstataue
                iu suba metodo sendas novan vicon de klaveventoj kun akompanaj
                launecesaj uskleco, stireco kaj alternativeco.

                Speciala problemo che tio estas la fakto, ke la klavoj, kiujn
                oni sendas, denove alvenas tra la traktilo KeyProc. Pro tio la
                klaso posedas buleajhon bBarita, kiu sciigas al la
                traktilo, ke ghi transsaltu tiajn memkreitajn pseudo-
                klavpremojn.

                Plia problemo rilatas al la komutado de la klavaro, ekzemple
                al la Esperanta Latin-3-a klavaro, au la internacia Usona
                klavaro. Tute ne estas problemo alshalti specifan klavaron kaj
                sendi kelkajn konvenajn klavpremojn kaj klavmalpremojn. Pli
                malfacile estas denove malshalti la fremdan klavaron. Tio ja
                okazu unue, post kiam chiuj de la klaso senditaj klaveventoj
                prepreterpasis. Pri tio, kiam tio estos okazinta, decidas tamen
                Vindozo. Kiel solvon la klaso metas specialan klaveventon
                che la fino de tia mem kreita klavsekvo. Kiam Vindozo fine
                prezentas ghin, tiam la programo reshaltas al la praa klavaro
                uzata de la uzulo. Por tio la tenilo de la malnova klavaro
                jam antaue estis stokata.

    ========================================================================
    Dato		Autoro			Modifo
    ========================================================================
    98.01.01	Jury Finkel		Prapretigo
    99.08.01	Simon Payne		Reordigo kaj enkonduko de klasoj
    99.08.28	Simon Payne		Reskribo de la klavarkomutado kun meto de
    							jhetono sur la stakon por lanchi la reshalton.
    99.08.29	Simon Payne		Reskribo de la diversaj metodoj nun baze de
    							la nombrilo iKeysToSkip por eviti trakti la
                                mem produktitajn klaveventojn
    99.08.29	Simon Payne		En eKlavaroRektaKajAU Alt-Ctrl plus Q,W,X,Y
    							nun produktas ne-Esperantajhojn. Simile chiuj
                                Esperantajhoj estas atingebla per la kombino
                                Alt-Ctrl plus C,G,H,J,S,U. Alt-Ctrl U varias
                                situacie lau bAu.
    99.08.30	Simon Payne		Mankanta iKeysToSkip in AU parto de
    							eKlavaroRektaKajAU enmetita
    99.08.31	Jury Finkel		Au-malshalta VK_RETURN aldonita en eKeyproc()
    99.09.04	Simon Payne		PRINTSET enmetita kaj inkrementado de
    							iKeysToSkip metita en posteulo de Send()
    99.10.11	Simon Payne		Entjero iKeysToSkip estas shanghita al duumajho
    							bBarita, kiu baras la tutan traktilon. Nun
                                la unua KeyDown() de sekvenco tuj baras
                                eKeyproc(). Fine de chiu konstruita sekvenco
                                sendighu per Malbaru() la jhetono VK_MALBARU,
                                kiu malbaras la traktilon kaj launecese
                                malshaltas fremdan klavaron.
    99.10.11	Simon Payne		Shajnas, ke iam kaj iam post komutado de la
    							klavaro, la tuj posta KeyDown perdighas. Pro
                                tio sendigas post chiu komutado nun VK_DUMMY.
    99.10.15	Simon Payne		Klaso TEKeys disigita.
    ========================================================================
}


interface

uses
	Windows,
    SysUtils,
    UKeys,
    ULib,
    URegData;

const
    GERMANA = false;
    VK_DUMMY =		#0;
    VK_MALBARU = 	#1;
    PRINTSET = [#32..#255];

type

	ETraktado = (eTraktota, eTraktita);
    EKlavaro = (eEsperanto, eInternacia);
    EDiakrito = (eVaka, eAkuto, eGravo, eCirkum, eTildo, eDiarezo, eSimbolo);

    TKeys_KBSwitch = class(TKeys)
    protected
        oIni: TRegData;
        bShaltita: Boolean;
        tPrev: THandle;
        function bShaltuKlavaron(peKlavaro: EKlavaro): boolean;
        procedure MalshaltuKlavaron;
    public
        constructor Create(poIni: TRegData);
    end;

    TKeys_Barred = class(TKeys_KBSwitch)
	protected
        bBarita: Boolean;
        procedure Malbaru;
        procedure Retro;
    public
        procedure KeyDown(piKey:integer); override;
    end;

    TEKeys = class(TKeys_Barred)
    protected
        bEspKeyboardMode: boolean;
        oEspDeadKey: TKey;
        bAu, bEspDead, bIntDead: boolean;
        eDiakrito: EDiakrito;
        function eSenduPerIntKlavaro(pcKey: Char;
        							 peDiakrito: EDiakrito): eTraktado;
        function eKlavaroInternacia: eTraktado;
        function eKlavaroRektaKajAU: eTraktado;
        function eKlavaroSenpasha: eTraktado;
    public
        function eKeyProc(piCode: Integer; plKey, plParam: Longint;
                          pbEspKeyboardMode: Boolean): ETraktado;
    end;

implementation

//==========================================================================

constructor TKeys_KBSwitch.Create(poIni: TRegData);
begin
    inherited Create(poIni.bNT);
    oIni:=poIni;
end;

function TKeys_KBSwitch.bShaltuKlavaron(peKlavaro: EKlavaro): boolean;
var
	ltKlavaro: THandle;
begin
	Result:=false;
	if bShaltita then
    	exit;
	ltKlavaro:=0;
	with oIni do
		case peKlavaro of
    		eEsperanto: 	ltKlavaro:=tEkla;
    		eInternacia: 	ltKlavaro:=tIKla;
		end;
    if ltKlavaro=0 then
    	exit;
    ltKlavaro:=tSelectKeyboard(ltKlavaro);
	if ltKlavaro=0 then
    	exit;
    bShaltita:=true;
    Send(VK_DUMMY);
    tPrev:=ltKlavaro;
    Result:=true;
end;

procedure TKeys_KBSwitch.MalshaltuKlavaron;
begin
    if not bShaltita then
    	exit;
	if(tPrev<>0) then
    	tSelectKeyboard(tPrev);
    bShaltita:=false;
    if (tPrev<>0) then
    	Send(VK_DUMMY);
    tPrev:=0;
end;

//==========================================================================

procedure TKeys_Barred.Malbaru;
begin
    Send(VK_MALBARU);
end;

procedure TKeys_Barred.Retro;
begin
    if oIni.bVidebla then
    begin
    	bBarita:=true;
        SendBack;
    end;
end;

procedure TKeys_Barred.KeyDown(piKey:integer);
begin
    bBarita:=true;
	inherited KeyDown(piKey);
end;

//==========================================================================

function TEKeys.eSenduPerIntKlavaro(pcKey: Char;
									peDiakrito: EDiakrito): eTraktado;
var
    lcSpecialKey: Char;
    liSpecialVK: Integer;
    lbSpecialShift: Boolean;
begin
    Result:=eTraktota;
    if oKey=nil then
    	exit;
    if (peDiakrito=eVaka) then
        exit;
    lcSpecialKey:=#0;
    lbSpecialShift:=false;
    case peDiakrito of
     eAkuto:	lcSpecialKey:='''';
     eGravo:	lcSpecialKey:='`';
     eCirkum: 	begin
            		lcSpecialKey:='6';
            		lbSpecialShift:=True;
        		end;
     eTildo: 	begin
            		lcSpecialKey:='`';
            		lbSpecialShift:=True;
        		end;
     eDiarezo: 	begin
            		lcSpecialKey:='''';
            		lbSpecialShift:=True;
        		end;
     eSimbolo:	begin
                    if bShaltuKlavaron(eInternacia) then
     				begin
                    	AltCtrlSend(pcKey);
                    	Result:=eTraktita;
                    	Malbaru;
                    end;
                    exit;
         		end;
	end;

    if bShaltuKlavaron(eInternacia) then with oKey do
    begin
    	liSpecialVK:=VkKeyScan(lcSpecialKey);
    	if bShift then
        	KeyUp(VK_Shift);
    	if lbSpecialShift then
        	KeyDown(VK_Shift);
    	KeyDown(liSpecialVK);
    	KeyUp(liSpecialVK);
    	if lbSpecialShift then
        	KeyUp(VK_Shift);
    	if bShift and not (bRShift and bNT) then
        	KeyDown(VK_Shift);
    	Send(pcKey);
    	Result:=eTraktita;
    	Malbaru;
    end;
end;

function TEKeys.eKlavaroInternacia: eTraktado;
begin
    Result:=eTraktota;
    if oKey=nil then
    	exit;
    with oKey do
    	if bAlt and (oIni.tIKla<>0) then	{unua trapaso kun senpashilo}
    	begin
    		if lKey=VkKeyScan('5') then
        		eDiakrito:=eAkuto
        	else if lKey=VkKeyScan('6') then
        		eDiakrito:=eGravo
        	else if lKey=VkKeyScan('''') then
        		eDiakrito:=vIf(bShift,eDiarezo,eAkuto)
        	else if lKey=VkKeyScan('`') then
        		eDiakrito:=vIf(bShift,eTildo,eGravo)
        	else if lKey=VkKeyScan('7') then
        		eDiakrito:=eCirkum
        	else if lKey=VkKeyScan('8') then
        		eDiakrito:=eTildo
        	else if lKey=VkKeyScan('9') then
        		eDiakrito:=eDiarezo
        	else if lKey=VkKeyScan('0') then
        		eDiakrito:=eSimbolo;
        	if eDiakrito<>eVaka then
            begin
            	bIntDead:=true;
        		Result:=eTraktita;
            end;
    	end
        else if eDiakrito<>eVaka then		{dua trapaso kun baza signo}
    	begin
        	eSenduPerIntKlavaro(cKey,eDiakrito);
        	eDiakrito:=eVaka;
            bIntDead:=false;
        	Result:=eTraktita;
    	end;
end;

function TEKeys.eKlavaroRektaKajAU: ETraktado;
begin
    Result:=eTraktota;
    if bShaltita then
    	exit;
    if bIntDead then
    	exit;
    if oKey=nil then
    	exit;
    with oKey do
    	if bAlt and bCtrl then
        begin
        	if cKey in ['H','U'] then
    		begin
        		if (cKey='U') and bAu then
            	begin
                	StripAltCtrlSend(cKey);
                	Result:=eTraktita;
                    Malbaru;
            	end
        		else if bShaltuKlavaron(eEsperanto) then
        		begin
        			Send(cKey);
            		Result:=eTraktita;
        			Malbaru;
        		end;
            end
            else if cKey in ['C','G','J','S'] then
            begin
        		if bShaltuKlavaron(eEsperanto) then
    			begin
    				case cKey of
        				'C': StripAltCtrlSend('X');
            			'S': StripAltCtrlSend('Q');
            			'J': StripAltCtrlSend('W');
            			'G': StripAltCtrlSend('Y');
        			end;
            		Result:=eTraktita;
        			Malbaru;
                end;
    		end
    		else if cKey in ['Q','X','W','Y'] then
    		begin
				StripAltCtrlSend(cKey);
            	Result:=eTraktita;
                Malbaru;
            end;
    	end
    	else if not bAlt and not bCtrl then
    	begin
    		if bEspKeyboardMode and (cKey in ['Q','X','W','Y']) then
    		begin
        		if bShaltuKlavaron(eEsperanto) then
            	begin
        			if bEspDead then
        			begin
            			Retro;
            			AltCtrlSend(cKey);
        			end
        			else
        				Send(cKey);  			{ Esperantaj signoj }
                	Result:=eTraktita;
        			Malbaru;
            	end;
        	end
    		else if (cKey='U') and bAu then
    		begin
    			if bShaltuKlavaron(eEsperanto) then
            	begin
        			AltCtrlSend(cKey);
                	Result:=eTraktita;
        			Malbaru;
            	end;
    		end;
    	end;
end;

function TEKeys.eKlavaroSenpasha: ETraktado;
var
    lsetTemp: set of char;
begin
    Result:=eTraktota;
    if bShaltita or not bEspDead then
    	exit;
    if bIntDead then
    	exit;
    if oKey=nil then
    	exit;
    lsetTemp:=['C','S','J','G','U','H'];
    if GERMANA then
    	lsetTemp:=['C','S','J','G','W','H'];
    with oKey do
    	if cKey in lsetTemp then
    	begin
        	Retro;
        	if bShaltuKlavaron(eEsperanto) then
    		begin
    			case cKey of
        			'C': Send('X');
            		'S': Send('Q');
            		'J': Send('W');
            		'G': Send('Y');
            		'U','W': 	if bAu then
                    				Send('U')
                    			else
                            		AltCtrlSend('U');
                	'H': AltCtrlSend('H');
        		end;
            	Result:=eTraktita;
        		Malbaru;
        	end;
    	end
    	else if GERMANA
        	 and (cKey in ['A','O','E','U','I'])
             and (oIni.tIKla<>0) then
    	begin
        	Retro;
            bIntDead:=true;
        	if cKey in ['A','O','U'] then
        		Result:=eSenduPerIntKlavaro(cKey, eDiarezo)
        	else if cKey = 'E' then
        		Result:=eSenduPerIntKlavaro('E', eAkuto)
        	else if cKey = 'I' then
        		Result:=eSenduPerIntKlavaro('S', eSimbolo);
            bIntDead:=false;
    	end
    	else
    	begin
        	if not oIni.bVidebla then
    		begin
            	if oEspDeadKey=nil then
                	exit;
        		if oEspDeadKey.bShift and not bShift then
        			KeyDown(VK_Shift);
        		Send(oEspDeadKey.cKey);
        		if oEspDeadKey.bShift and not bShift then
        			KeyUp(VK_Shift);
            	if cKey<>oEspDeadKey.cKey then
        			Send(cKey);
        		Result:=eTraktita;
                Malbaru;
        	end;
    	end;
end;


function TEKeys.eKeyProc(piCode: Integer; plKey, plParam: Longint;
                         pbEspKeyboardMode: boolean): ETraktado;
begin
  Result:=eTraktota;
  try
  		oKey:=TKey.Create(piCode, plKey, plParam);
        bEspKeyboardMode:=pbEspKeyboardMode;
        with oKey do
        	if bAction or bNoRemove then
        	begin
            	if bExt then
            		exit;
            	if bDown then
            	begin
            		if cKey=VK_MALBARU then
                	begin
                    	if bShaltita then
                			MalshaltuKlavaron;
                        bBarita:=false;
                        bAu:=false;
                    	Result:=eTraktita;
                	end
                    else if cKey=VK_DUMMY then
                    	Result:=eTraktita
                    else if bBarita then

                    else if lKey=VK_Tab or VK_Return then
                    	bAu:=false
                	else if (lKey=VK_Back) and not bEspDead then
                    	bAu:=False
                	else if bLatinKB and (cKey in PRINTSET) then
                	begin
                    	Result:=eKlavaroRektaKajAU;
                    	if Result=eTraktota then
                        	Result:=eKlavaroSenpasha;
                    	if Result=eTraktota then
                            Result:=eKlavaroInternacia;
//                        Result:=eTraktota;  {Test}
                        bEspDead:=false;
                        oEspDeadKey.Free;
                        if not bShaltita and not bAlt and not bCtrl then
                        begin
                    		if (iScan=oIni.iMK_1)
                            or (iScan=oIni.iMK_2) then
                            begin
                            	bEspDead:=true;
                        		oEspDeadKey:=oKey;
                        		Result:=vIf(oIni.bVidebla,eTraktota,eTraktita);
                            end;
                            bAu:=(cKey in ['A','E']) and oIni.bAuto;
                    	end;
                	end;
            	end;
        	end;
    except
    	Beep;
    end;
end;

end.
