unit frmInstall;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Registry, Buttons, ExtCtrls, Groups, Esperanto;

type
  TFInstall = class(TForm)
    ButtonOk: TButton;
    ButtonCancel: TButton;
    CheckBox1: TCheckBox;
    Image1: TImage;
    Edit1: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Bevel4: TBevel;
    ButtonBrowse: TSpeedButton;
    myLabel1: TeoLabel;
    myLabel2: TeoLabel;
    ListBox1: TeoListBox;
    ListBox2: TeoListBox;
    procedure FormCreate(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure ListBox1Enter(Sender: TObject);
    procedure ListBox1Exit(Sender: TObject);
    procedure ListBox2Enter(Sender: TObject);
    procedure ListBox2Exit(Sender: TObject);
    procedure ButtonOkClick(Sender: TObject);
    procedure CheckBox1Enter(Sender: TObject);
    procedure CheckBox1Exit(Sender: TObject);
    procedure Edit1Enter(Sender: TObject);
    procedure Edit1Exit(Sender: TObject);
    procedure ButtonBrowseClick(Sender: TObject);
    procedure Label1Click(Sender: TObject);
    procedure Label2Click(Sender: TObject);
    procedure Label3Click(Sender: TObject);
    procedure Label4Click(Sender: TObject);
  private
  public
  end;

var
  FInstall: TFInstall;

const
  clCream = TColor($A6CAF0);
  clMoneyGreen = TColor($C0DCC0);
  clSkyBlue = TColor($FFFBF0);

function DoInstall: Boolean;
function UndoInstall: Boolean;
procedure RegistryChange;
procedure SelfDelete;

implementation

uses frmBrowse, frmProgress;

{$R *.DFM}

var SystemPath: String;
    VInfo: TOSVersionInfo;
    Ok: boolean;

{Ricevu informon pri la sistemo}
procedure GetSysInfo;
 var Buf: array [0..1024] of Char;
begin
  GetSystemDirectory(Buf,sizeof(Buf));
  SystemPath:=Buf;
  VInfo.dwOSVersionInfoSize:=sizeof(TOSVersionInfo);
  Ok:=GetVersionExA(VInfo);
  if SystemPath[length(SystemPath)]<>'\' then
        SystemPath:=SystemPath+'\';
end; {GetSysInfo}

procedure TFInstall.FormCreate(Sender: TObject);
begin
  GetSysInfo;
  ListBox1.ItemIndex:=0;
  ListBox1Click(Sender);
  ListBox2.ItemIndex:=0;
  Edit1.Text:=ExtractFileDrive(SystemPath)+'\Program Files\Ek';

  ListBox1.Items.Add('Balta');          //1257
  ListBox1.Items.Add('Centreuxropa');    //1250
  ListBox1.Items.Add('Okcidenteuxropa'); //1252
  ListBox1.Items.Add('Turka (malrekomendata)');          //1254
  ListBox1.ItemIndex:=0;
  ListBox1Click(Sender);
end; {TFInstall.FormCreate}

{Post klako sur la maldekstra listo kreu la dekstran}
procedure TFInstall.ListBox1Click(Sender: TObject);
begin
    ListBox2.Items.Clear;
    case ListBox1.ItemIndex of
     0: begin
            ListBox2.Items.Add('Estona');   //est
            ListBox2.Items.Add('Latva');    //lv
            ListBox2.Items.Add('Litova');   //lt
        end;
     1: begin
            ListBox2.Items.Add('Albana');           //al
            ListBox2.Items.Add('Cxehxa');           //cz
            ListBox2.Items.Add('Hungara');          //hu
            ListBox2.Items.Add('Kroata');           //cr
            ListBox2.Items.Add('Pola');             //pl
            ListBox2.Items.Add('Rumana');           //ro
            ListBox2.Items.Add('Slovaka');          //sl
            ListBox2.Items.Add('Slovena');          //sv
        end;
     2: begin
            ListBox2.Items.Add('Dana');             //da
            ListBox2.Items.Add('Islanda');          //ic
            ListBox2.Items.Add('Norvega');          //no
        end;
     3: begin
            ListBox2.Items.Add('Turka');            //tuq
        end;
    end;
    ListBox2.ItemIndex:=0;
end; {TFInstall.ListBox1Click}

{Tabeloj de signaroj, lingvoj ktp}
const CodePage: array [0..3] of String =
       ('1257','1250','1252','1254');
      CharSet: array [0..3] of integer =
       (BALTIC_CHARSET, EASTEUROPE_CHARSET,ANSI_CHARSET,TURKISH_CHARSET);
      Lang: array [0..3,0..7] of String =
       (('est','lv','lt','','','','',''),
        ('al','cz','hu','cr','pl','ro','sl','sv'),
        ('da','ic','no','','','','',''),
        ('tuq','','','','','','',''));
      Locales: array [0..3,0..7] of String =
       (('00000425','00000426','00000427','','','','',''),
        ('0000041c','00000405','0000040e','0000041a',
                    '00000415','00000418','0000041b','00000424'),
        ('00000406','0000040f','00000414','','','','',''),
        ('0000041f','','','','','','',''));

procedure TFInstall.ListBox1Enter(Sender: TObject);
begin
    ListBox1.Color:=clInfoBk;
    Bevel1.Show;
end; {TFInstall.ListBox1Enter}

procedure TFInstall.ListBox1Exit(Sender: TObject);
begin
    ListBox1.Color:=clMoneyGreen;
    Bevel1.Hide;
end; {TFInstall.ListBox1Exit}

procedure TFInstall.ListBox2Enter(Sender: TObject);
begin
    ListBox2.Color:=clInfoBk;
    Bevel2.Show;
end; {TFInstall.ListBox2Enter}

procedure TFInstall.ListBox2Exit(Sender: TObject);
begin
    ListBox2.Color:=clMoneyGreen;
    Bevel2.Hide;
end; {TFInstall.ListBox2Exit}

{Prenu unuan vorton de linio}
function GetWord (S: String): String;
 var i: Integer;
begin
    result:='';
    for i:=1 to length(S) do
        if S[i]<>' ' then
            result:=result+S[i]
        else break;
end; {GetWord}

var CP, CP0, CP1, CP2, CP3,
    KBD, KBD0, KBD1, KBD2, Locale,
    ProgPath, RezPath, Path: String;

procedure TFInstall.ButtonOkClick(Sender: TObject);
begin
    Path:=ExtractFilePath(ParamStr(0));
    ModalResult:=mrNone;
    if Listbox1.ItemIndex<0 then exit;
    if Listbox2.ItemIndex<0 then exit;

    ProgPath:=Edit1.Text;
    if ProgPath[length(ProgPath)]<>'\' then
        ProgPath:=ProgPath+'\';
    RezPath:=ProgPath+'REZ\';
    CP:=CodePage[Listbox1.ItemIndex];
    CP2:=CP; CP1:=CP2; CP0:=CP2; CP3:='28593';
    if CP1<>'1252' then CP1:=CP3;
    KBD2:=Lang[Listbox1.ItemIndex,Listbox2.ItemIndex];
    if VInfo.dwPlatformId=VER_PLATFORM_WIN32_WINDOWS then
        if KBD2='est' then KBD2:='es';
    KBD1:='eo'; KBD0:=KBD2; KBD:=KBD2;
    Locale:=Locales[Listbox1.ItemIndex,Listbox2.ItemIndex];
    case VInfo.dwPlatformId of
     VER_PLATFORM_WIN32_WINDOWS:
        begin
            CP0:={RezPath+}'cp_'+CP0+'.nls';
            CP1:={Path+}'cp_'+CP1+'.nls';
            CP2:={SystemPath+}'cp_'+CP2+'.nls';
            CP3:='cp_'+CP3+'.nls';
            KBD:='kbd'+KBD+'.kbd';
            KBD0:={RezPath+}'kbd'+KBD0+'.kbd';
            KBD1:={Path+}'kbd'+KBD1+'.kbd';
            KBD2:={SystemPath+}'kbd'+KBD2+'.kbd';
        end;
     VER_PLATFORM_WIN32_NT:
        begin
            CP0:={RezPath+}'c_'+CP0+'.nls';
            CP1:={Path+}'c_'+CP1+'.nls';
            CP2:={SystemPath+}'c_'+CP2+'.nls';
            CP3:='c_'+CP3+'.nls';
            KBD:='kbd'+KBD+'.dll';
            KBD0:={RezPath+}'kbd'+KBD0+'.dll';
            KBD1:={Path+}'kbd'+KBD1+'.dll';
            KBD2:={SystemPath+}'kbd'+KBD2+'.dll';
        end;
    end;
    ModalResult:=mrOk;
end; {TFInstall.ButtonOkClick}

procedure TFInstall.Edit1Enter(Sender: TObject);
begin
    Bevel3.Show;
end; {TFInstall.Edit1Enter}

procedure TFInstall.Edit1Exit(Sender: TObject);
begin
    Bevel3.Hide;
end; {TFInstall.Edit1Exit}

procedure TFInstall.CheckBox1Enter(Sender: TObject);
begin
    Bevel4.Show;
    Label4.BringToFront;
end; {TFInstall.CheckBox1Enter}

procedure TFInstall.CheckBox1Exit(Sender: TObject);
begin
    Bevel4.Hide;
end; {TFInstall.CheckBox1Exit}

procedure TFInstall.ButtonBrowseClick(Sender: TObject);
begin
{$I-}
    MkDir(ExtractFileDrive(SystemPath)+'\Program Files\');
    if IOResult<>0 then;
{$I+}
    FBrowse.Edit1.Text:=ExtractFileDrive(SystemPath)+'\Program Files';
    FBrowse.DirectoryListBox1.Directory:=ExtractFileDrive(SystemPath)+'\Program Files';
    if FBrowse.ShowModal=mrOk then
        Edit1.Text:=FBrowse.Edit1.Text;
end; {TFInstall.ButtonBrowseClick}

procedure Over (Src,Dst: String);
 var InpFile,OutFile: TFileStream;
begin
  //try
    if not FileExists(Src) then exit;
    InpFile:=TFileStream.Create(Src,fmOpenRead);
    if FileExists(Dst) then
        OutFile:=TFileStream.Create(Dst,fmOpenReadWrite)
    else
        OutFile:=TFileStream.Create(Dst,fmCreate);
    OutFile.CopyFrom(InpFile,0);
    SetEndOfFile(OutFile.Handle);
    OutFile.Free;
    InpFile.Free;
  //except
  //end;
end; {Over}

function GetFileSize (const FileName: string): Longint;
 var SearchRec: TSearchRec;
begin
  if FindFirst(ExpandFileName(FileName), faAnyFile, SearchRec) = 0 then
    Result:=SearchRec.Size
  else Result:=0;
  FindClose(SearchRec);
end; {GetFileSize}

{Anstatauigu chenon A per cheno B en linio S}
procedure Change (var S: String; A,B: String);
 var n: Integer;
begin
     n:=Pos(A,S);
     if n>0 then
     begin
          Delete(S,n,length(A));
          Insert(B,S,n);
     end;
end; {Change}

function LongToShortFileName (const LongName: string): string;
var
  Temp: TWin32FindData;
  SearchHandle: THandle;
begin
  SearchHandle := FindFirstFile(PChar(LongName), Temp);
  if SearchHandle <> INVALID_HANDLE_VALUE then begin
    Result := string(Temp.cAlternateFileName);
    if Result = '' then Result := string(Temp.cFileName);
  end
  else Result := '';
  Windows.FindClose(SearchHandle);
end; {LongToShortFileName}

function LongToShortPath (const LongName: string): string;
 var Temp: array [0..512] of char;
     LastSlash: PChar;
     TempPathPtr: PChar;
begin
  Result := '';
  StrLCopy(Temp,PChar(LongName),512);
  TempPathPtr := Temp;
  LastSlash := StrRScan(TempPathPtr, '\');
  while LastSlash <> nil do
  begin
    Result := '\' + LongToShortFileName(TempPathPtr) + Result;
    if LastSlash <> nil then
    begin
      LastSlash^ := char(0);
      LastSlash := StrRScan(TempPathPtr, '\');
    end;
  end;
  Result := TempPathPtr + Result;
end; {LongToShortPath}

{Kreu instal-dosieron por Vindozo 9x}
procedure Over95 (List: array of String);
 var szWinInitFile: array [1..256] of char;
     S: String;
     i: Integer;
begin
  GetWindowsDirectory(@szWinInitFile, 256);
  lstrcat(@szWinInitFile, '\\WININIT.INI');
  i:=Low(List);
  while i<High(List) do
  begin
       S:=List[i+1];
       Change(List[i+1],'.nls','.1');
       Change(List[i+1],'.kbd','.1');
       Change(List[i+1],'.dll','.1');
       WritePrivateProfileString('Rename',
           PChar(S), PChar(List[i+1]), @szWinInitFile);
       Over(List[i],List[i+1]);
       FProgress.ProgressBar1.StepBy(GetFileSize(List[i+1]));
       Inc(i,2);
  end;
end; {Over95}

function EstasEk: Boolean;
  var AppMutex: THandle;
begin
    result:=False;
    AppMutex := OpenMutex(MUTEX_ALL_ACCESS, False, 'Ek!');
    if AppMutex <> 0 then
    begin
      CloseHandle(AppMutex);
      beep;
      MessageDlg('Unue haltigu "Ek"-on!',mtError,[mbOk],0);
      result:=True;
      exit;
    end;
end; {CheckEk}

{Propre instalado}
function DoInstall: Boolean;
 var SumSize: LongInt;
     SearchRec: TSearchRec;
begin
    result:=True;
    if EstasEk then
    begin
      result:=False;
      exit;
    end;
{$I-}
    MkDir(ProgPath); if IOResult<>0 then;
    MkDir(ProgPath+'REZ\'); if IOResult<>0 then;
    MkDir(ProgPath+'Helpo\'); if IOResult<>0 then;
{$I+}
    FProgress.Show;
    with FProgress do
    begin
        SumSize:=GetFileSize(Path+'ek.exe')+
            GetFileSize(Path+'ek.txt')+
            GetFileSize(Path+'eklav.dll')+
            GetFileSize(Path+'legumin.txt')+
            GetFileSize(Path+'install.exe')+
            GetFileSize(Path+CP3)+
            GetFileSize(Path+CP1)+GetFileSize(SystemPath+CP2)+
            GetFileSize(Path+KBD1)+GetFileSize(SystemPath+KBD2);
        if FindFirst(Path+'Helpo\*.*', 0, SearchRec) = 0 then
        begin
            SumSize:=SumSize+GetFileSize(Path+'Helpo\'+SearchRec.Name);
            while FindNext(SearchRec)=0 do
                SumSize:=SumSize+GetFileSize(Path+'Helpo\'+SearchRec.Name);
        end;
        FindClose(SearchRec);

        ProgressBar1.Max:=SumSize;
        ProgressBar1.Min:=0;
        Refresh;
        myText1.Enabled:=True; myText1.Refresh;
        if FileExists(SystemPath+CP2) and not FileExists(RezPath+CP0) then
        begin
            Label1.Caption:='Rezervado de '+SystemPath+CP2;
            Label1.Refresh;
            CopyFile(PChar(SystemPath+CP2),PChar(RezPath+CP0),False);
        end;
        ProgressBar1.StepBy(GetFileSize(SystemPath+CP2));
        if FileExists(SystemPath+KBD2) and not FileExists(RezPath+KBD0) then
        begin
            Label1.Caption:='Rezervado de '+SystemPath+KBD2;
            Label1.Refresh;
            CopyFile(PChar(SystemPath+KBD2),PChar(RezPath+KBD0),False);
        end;
        ProgressBar1.StepBy(GetFileSize(SystemPath+KBD2));

        mytext2.Enabled:=True; mytext2.Refresh;
        Label1.Caption:='ek.exe'; Label1.Refresh;
        CopyFile(PChar(Path+'ek.exe'),PChar(ProgPath+'ek.exe'),False);
        ProgressBar1.StepBy(GetFileSize(Path+'ek.exe'));
        Label1.Caption:='ek.txt'; Label1.Refresh;
        CopyFile(PChar(Path+'ek.txt'),PChar(ProgPath+'ek.txt'),False);
        ProgressBar1.StepBy(GetFileSize(Path+'ek.txt'));
        Label1.Caption:='eklav.dll'; Label1.Refresh;
        CopyFile(PChar(Path+'eklav.dll'),PChar(ProgPath+'eklav.dll'),False);
        ProgressBar1.StepBy(GetFileSize(Path+'eklav.dll'));
        Label1.Caption:='legumin.txt'; Label1.Refresh;
        CopyFile(PChar(Path+'legumin.txt'),PChar(ProgPath+'legumin.txt'),False);
        ProgressBar1.StepBy(GetFileSize(Path+'legumin.txt'));
        Label1.Caption:='malinst.exe'; Label1.Refresh;
        CopyFile(PChar(Path+'install.exe'),PChar(ProgPath+'malinst.exe'),False);
        ProgressBar1.StepBy(GetFileSize(Path+'install.exe'));
//      CopyFile(PChar(Path+'t.pif'),PChar(ProgPath+'t.pif'),False);

        if FindFirst(Path+'Helpo\*.*', 0, SearchRec) = 0 then
        begin
                Label1.Caption:='Helpo\'+SearchRec.Name; Label1.Refresh;
                CopyFile(PChar(Path+'Helpo\'+SearchRec.Name),
                         PChar(ProgPath+'Helpo\'+SearchRec.Name),False);
                ProgressBar1.StepBy(GetFileSize(Path+'Helpo\'+SearchRec.Name));
                while FindNext(SearchRec)=0 do
                begin
                    Label1.Caption:='Helpo\'+SearchRec.Name; Label1.Refresh;
                    CopyFile(PChar(Path+'Helpo\'+SearchRec.Name),
                         PChar(ProgPath+'Helpo\'+SearchRec.Name),False);
                    ProgressBar1.StepBy(GetFileSize(Path+'Helpo\'+SearchRec.Name));
                end;
        end;
        FindClose(SearchRec);

        myText3.Enabled:=True; myText3.Refresh;
        Label1.Caption:=''; Label1.Refresh;
        RegistryChange;

        Groups.MakeDesktopIcon(ProgPath+'ek.exe','');
        myText4.Enabled:=True; myText4.Refresh;
        if VInfo.dwPlatformId=VER_PLATFORM_WIN32_NT then
        begin
            Over(Path+CP3,SystemPath+CP3);
            ProgressBar1.StepBy(GetFileSize(Path+CP3));
            Over(Path+CP1,SystemPath+CP2);
            ProgressBar1.StepBy(GetFileSize(Path+CP1));
            Over(Path+KBD1,SystemPath+KBD2);
            ProgressBar1.StepBy(GetFileSize(Path+KBD1));
        end
        else begin
            Over95([Path+CP3,SystemPath+CP3,
                           Path+CP1,SystemPath+CP2,
                           Path+KBD1,SystemPath+KBD2]);

            if mrYes=MessageDlg('Por kompletigo de instalo '+
                'Vindozo devas esti restartigita!',mtInformation,[mbYes,mbNo],0) then
                ExitWindowsEx(EWX_REBOOT,0);
            result:=False;
        end;
    end;
end; {DoInstall}

procedure RegistryChange;
 label ok;
 type TLevel = array [0..3] of Byte;
 const CLevel: TLevel =(3,7,0,0);
 var Ini: TRegistry;
     Level: TLevel;
     S,K: String;
     i: Integer;
     Strings: TStringList;
begin
    Strings:=TStringList.Create;
    Ini:=TRegistry.Create;
    Ini.RootKey:=HKEY_CLASSES_ROOT;
    Ini.OpenKey('MIME\Database\Codepage\28593',True);
    Level:=CLevel;
    Ini.WriteString('BodyCharset','iso-8859-3');
    Ini.WriteString('Description','Latin 3 (ISO)');
    Ini.WriteInteger('Family',1254);
    Ini.WriteBinaryData('Level',Level, 4);

    Ini.RootKey:=HKEY_LOCAL_MACHINE;
    Ini.OpenKey('\SYSTEM\CurrentControlSet\Control\Nls\CodePage',True);
    if VInfo.dwPlatformId=VER_PLATFORM_WIN32_NT then
    begin
        Ini.WriteString('28593','c_28593.nls');
        Ini.WriteString(CP,'c_'+CP+'.nls');
    end
    else begin
        Ini.WriteString('28593','cp_28593.nls');
        Ini.WriteString(CP,'cp_'+CP+'.nls');
    end;

    Ini.RootKey:=HKEY_LOCAL_MACHINE;
    Ini.OpenKey('\SYSTEM\CurrentControlSet\Control\Nls\Language',True);
    S:=Copy(Locale,5,10);
    Ini.WriteString(Copy(Locale,5,10),'l_intl.nls');

    Ini.RootKey:=HKEY_LOCAL_MACHINE;
    Ini.OpenKey('\SYSTEM\CurrentControlSet\Control\Keyboard Layouts\'+Locale,True);
    S:=Ini.ReadString('Layout File');
    if S='' then
        Ini.WriteString('Layout File',UpperCase(KBD));
    S:=Ini.ReadString('Layout Text');
    if S='' then
        Ini.WriteString('Layout Text','Esperanto');

    Ini.RootKey:=HKEY_LOCAL_MACHINE;
    Ini.OpenKey('\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Ek',True);
    Ini.WriteString('DisplayName','Ek!');
    Ini.WriteString('UninstallString',ProgPath+'malinst.exe');

    Ini.RootKey:=HKEY_CURRENT_USER;
    Ini.OpenKey('\Software\Ek',True);
    Ini.WriteString('Locale',Locale);
    Ini.WriteString('Path',ProgPath+'ek.exe');
    Ini.WriteString('FontCharSet',IntToStr(CharSet[FInstall.Listbox1.ItemIndex]));
    if UseUnicode then
        Ini.WriteString('UseUnicode','1')
    else
        Ini.WriteString('UseUnicode','0');

    Ini.RootKey:=HKEY_CURRENT_USER;
    K:='\Keyboard Layout\Preload';
    if not Ini.OpenKey(K,False) then
    begin
        K:='\keyboard layout\preload';
        Ini.OpenKey(K,False);
    end;

    Ini.GetValueNames(Strings);
    if Strings.Count>0 then
    begin
        for i:=0 to Strings.Count-1 do
        begin
            S:=Ini.ReadString(Strings.Strings[i]);
            if S=Locale then goto ok;
        end;
        Str(Strings.Count+1,S);
        Ini.WriteString(S,Locale);
    end
    else begin
        Ini.GetKeyNames(Strings);
        for i:=0 to Strings.Count-1 do
        begin
            Ini.OpenKey(K+'\'+Strings.Strings[i],False);
            S:=Ini.ReadString('');
            if S=Locale then goto ok;
        end;
        Str(Strings.Count+1,S);
        Ini.OpenKey(K+'\'+S,True);
        Ini.WriteString('',Locale);
    end;
ok: LoadKeyboardLayout(PChar(Locale),0);
    if FInstall.CheckBox1.Checked then
    begin
        Ini.RootKey:=HKEY_CURRENT_USER;
        Ini.OpenKey('\Software\Ek',True);
        Ini.WriteString('AutoStart','1');
        Ini.OpenKey('\Software\Microsoft\Windows\CurrentVersion\Run',True);
        Ini.WriteString('Ek','"'+ProgPath+'ek.exe"');
        Ini.Free;
    end;
    Strings.Free;
end; {RegistryChange}

procedure DelDir (D: String);
 var SearchRec: TSearchRec;
begin   if FindFirst(D+'*.*',
            faReadOnly or faHidden or faSysFile or faArchive or faDirectory,
            SearchRec)=0 then
        repeat
            if SearchRec.Name[1]='.' then
            else if (SearchRec.Attr and faDirectory)=0 then
                DeleteFile(D+SearchRec.Name)
            else if SearchRec.Name[1]<>'.' then
                DelDir(D+SearchRec.Name+'\');
        until FindNext(SearchRec)<>0;
        FindClose(SearchRec);
        {$I-}
        RmDir(D);
        if IOResult<>0 then;
        {$I+}
end; {DelDir}

{Malinstalo}
function UndoInstall: Boolean;
 var SearchRec: TSearchRec;
     Ini: TRegistry;
     i,n: Integer;
     P,S,K: String;
     Strings: TStringList;
     szWinInitFile: array [1..256] of char;
begin
    result:=True;

    if EstasEk then
    begin
      result:=False;
      exit;
    end;

    GetSysInfo;

    if SystemPath[length(SystemPath)]<>'\' then
        SystemPath:=SystemPath+'\';

    ProgPath:=ExtractFilePath(ParamStr(0));
    if ProgPath[length(ProgPath)]<>'\' then
        ProgPath:=ProgPath+'\';

    Strings:=TStringList.Create;
    Ini:=TRegistry.Create;

    Ini.RootKey:=HKEY_LOCAL_MACHINE;
    Ini.DeleteKey('\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Ek');

    Ini.RootKey:=HKEY_CURRENT_USER;
    Ini.OpenKey('\Software\Microsoft\Windows\CurrentVersion\Run',False);
    Ini.DeleteValue('Ek');

    Ini.OpenKey('\Software\Ek',True);
    Locale:=Ini.ReadString('Locale');
    P:=Ini.ReadString('Path');
    P:=ExtractFilePath(P);
    if P='' then P:=ProgPath;

    Ini.RootKey:=HKEY_CURRENT_USER;
    K:='\Keyboard Layout\Preload';
    if not Ini.OpenKey(K,False) then
    begin
        K:='\keyboard layout\preload';
        Ini.OpenKey(K,False);
    end;

    n:=0;
    Ini.GetValueNames(Strings);
    if Strings.Count>0 then
    begin
        for i:=0 to Strings.Count-1 do
        begin
            S:=Ini.ReadString(Strings.Strings[i]);
            if S=Locale then
            begin
                Ini.DeleteValue(Strings.Strings[i]);
                Inc(n);
            end
            else if (i-n>=0) and (n>0) then
                Ini.RenameValue(Strings.Strings[i],Strings.Strings[i-n]);
        end;
    end
    else begin
        Ini.GetKeyNames(Strings);
        for i:=0 to Strings.Count-1 do
        begin
            Ini.OpenKey(K+'\'+Strings.Strings[i],False);
            S:=Ini.ReadString('');
            if S=Locale then
            begin
                Ini.DeleteKey(K+'\'+Strings.Strings[i]);
                Inc(n);
            end
            else if (i-n>=0) and (n>0) then
                Ini.MoveKey(K+'\'+Strings.Strings[i],
                    K+'\'+Strings.Strings[i-n],False);
        end;
    end;

    Strings.Free;
    Ini.Free;
    UnloadKeyboardLayout(LoadKeyboardLayout(PChar(Locale),0));

    if FindFirst(ProgPath+'REZ\*.*',
            faReadOnly or faHidden or faSysFile or faArchive,
            SearchRec)=0 then
    begin
        if VInfo.dwPlatformId=VER_PLATFORM_WIN32_NT then
            repeat
                FProgress.Label1.Caption:='Restarigo de '+SearchRec.Name;
                FProgress.Refresh;
                Over(ProgPath+'REZ\'+SearchRec.Name,
                     SystemPath+SearchRec.Name);
            until FindNext(SearchRec)<>0
        else begin
            repeat
                FProgress.Label1.Caption:='Restarigo de '+SearchRec.Name;
                FProgress.Refresh;
                Over95([ProgPath+'REZ\'+SearchRec.Name,SystemPath+SearchRec.Name]);
            until FindNext(SearchRec)<>0;
            GetWindowsDirectory(@szWinInitFile, 256);
            lstrcat(@szWinInitFile, '\\WININIT.INI');
            WritePrivateProfileString('Rename','NUL',
               PChar(LongToShortPath(P+'malinst.exe')),@szWinInitFile);
        end;
    end;
    FindClose(SearchRec);

    DelDir(P+'REZ\');
    DelDir(P+'Helpo\');
    DeleteFile(P+'ek.exe');
    DeleteFile(P+'malinst.exe');
    DeleteFile(P+'eklav.dll');
    DeleteFile(P+'ek.txt');
    DeleteFile(P+'legumin.txt');
    Groups.DelDesktopIcon;
    if VInfo.dwPlatformId<>VER_PLATFORM_WIN32_NT then
    begin
        if mrYes=MessageDlg('Por kompletigo de malinstalo '+
               'Vindozo devas esti restartigita!',
               mtInformation,[mbYes,mbNo],0) then
            ExitWindowsEx(EWX_REBOOT,0);
        result:=False;
    end;
end; {UndoInstall}

procedure TFInstall.Label1Click(Sender: TObject);
begin
    ActiveControl:=ListBox1;
end; {TFInstall.Label1Click}

procedure TFInstall.Label2Click(Sender: TObject);
begin
    ActiveControl:=ListBox2;
end; {TFInstall.Label2Click}

procedure TFInstall.Label3Click(Sender: TObject);
begin
    ActiveControl:=Edit1;
end; {TFInstall.Label3Click}

procedure TFInstall.Label4Click(Sender: TObject);
begin
    if ActiveControl<>CheckBox1 then
        ActiveControl:=CheckBox1
    else
        CheckBox1.Checked:=not CheckBox1.Checked;
end; {TFInstall.Label4Click}

{Memforigo de la instalilo por Vindozo NT}
procedure SelfDelete;
 var f: TextFile;
     Buf: array [0..255] of char;
     i: Integer;
     b: BOOL;
     si: TStartupInfo;
     pri: TProcessInformation;
     bat,s: String;
begin
  GetEnvironmentVariable('TMP',Buf,sizeof(Buf));
  bat:=string(Buf)+'\zxcv.bat';
  begin
    Assign(f,bat);
    Rewrite(f);
    writeln(f,'@echo off');
    s:=ParamStr(0);
    SetFileAttributes(PChar(s),0);
    writeln(f,'del ',s);
    for i:=0 to 7 do
    begin
      writeln(f,'IF EXIST "',s,'" echo x >"',s,'"');
      writeln(f,'IF EXIST "',s,'" del "',s,'"');
    end;
    writeln(f,'del ',bat);
    for i:=0 to 7 do
    begin
      writeln(f,'IF EXIST "',bat,'" echo x >',bat);
      writeln(f,'IF EXIST "',bat,'" del ',bat);
    end;
    close(f);
    GetEnvironmentVariable('COMSPEC',Buf,sizeof(Buf));
    GetStartupInfo(si);
    with si do
    begin
      dwFlags:=dwFlags or STARTF_USESHOWWINDOW;
      wShowWindow:=SW_HIDE;
    end;
    b:=CreateProcess(nil,PChar(String(Buf)+' /c '+bat),nil,nil,false,CREATE_NEW_CONSOLE,nil,nil,si,pri);
    if b then
    with pri do
    begin
      CloseHandle(hThread);
      CloseHandle(hProcess);
    end else
    begin
      MessageBeep($FFFFFFFF);
    end
  end;
end; {SelfDelete}

end.
